Properly handle bazel's output deletion within a write-protected directory.
Currently, we fail in deleting outputs from a previous invocation in a write-protected directory.
This change retries deleting the outputs, after making the parent write-protected directory writable again.
--
MOS_MIGRATED_REVID=140035023
diff --git a/src/main/java/com/google/devtools/build/lib/actions/AbstractAction.java b/src/main/java/com/google/devtools/build/lib/actions/AbstractAction.java
index dd4dc97..dc18578 100644
--- a/src/main/java/com/google/devtools/build/lib/actions/AbstractAction.java
+++ b/src/main/java/com/google/devtools/build/lib/actions/AbstractAction.java
@@ -370,11 +370,22 @@
// Optimize for the common case: output artifacts are files.
path.delete();
} catch (IOException e) {
- // Only try to recursively delete a directory if the output root is known. This is just a
- // sanity check so that we do not start deleting random files on disk.
- // TODO(bazel-team): Strengthen this test by making sure that the output is part of the
- // output tree.
- if (path.isDirectory(Symlinks.NOFOLLOW) && output.getRoot() != null) {
+ // Handle a couple of scenarios where the output can still be deleted, but make sure we're not
+ // deleting random files on the filesystem.
+ if (output.getRoot() == null) {
+ throw e;
+ }
+ String outputRootDir = output.getRoot().getPath().getPathString();
+ if (!path.getPathString().startsWith(outputRootDir)) {
+ throw e;
+ }
+
+ Path parentDir = path.getParentDirectory();
+ if (!parentDir.isWritable() && parentDir.getPathString().startsWith(outputRootDir)) {
+ // Retry deleting after making the parent writable.
+ parentDir.setWritable(true);
+ deleteOutput(output);
+ } else if (path.isDirectory(Symlinks.NOFOLLOW)) {
FileSystemUtils.deleteTree(path);
} else {
throw e;
diff --git a/src/test/shell/integration/BUILD b/src/test/shell/integration/BUILD
index 078e962..717b8a1 100644
--- a/src/test/shell/integration/BUILD
+++ b/src/test/shell/integration/BUILD
@@ -135,6 +135,13 @@
)
sh_test(
+ name = "force_delete_output_test",
+ size = "medium",
+ srcs = ["force_delete_output_test.sh"],
+ data = [":test-deps"],
+)
+
+sh_test(
name = "ide_info_generation_native",
size = "large",
srcs = ["ide_info_generation.sh"],
diff --git a/src/test/shell/integration/force_delete_output_test.sh b/src/test/shell/integration/force_delete_output_test.sh
new file mode 100755
index 0000000..9b6fbd8
--- /dev/null
+++ b/src/test/shell/integration/force_delete_output_test.sh
@@ -0,0 +1,90 @@
+#!/bin/bash
+#
+# Copyright 2016 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# Test to ensure blaze forcibly deletes outputs from previous runs even if
+# they reside in a write protected directory.
+
+# Load the test setup defined in the parent directory
+CURRENT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+source "${CURRENT_DIR}/../integration_test_setup.sh" \
+ || { echo "integration_test_setup.sh not found!" >&2; exit 1; }
+
+
+function tear_down() {
+ bazel clean
+ bazel shutdown
+ rm -rf x
+}
+
+function test_delete_in_unwritable_dir() {
+ mkdir -p x || fail "Can't create x"
+ cat > x/BUILD << 'EOF'
+genrule(
+ name = "unwritable",
+ srcs = [],
+ outs = ["unwritable/somefile.out"],
+ local = 1,
+ cmd = "echo 'Some output' > $@; chmod -w $$(dirname $@)"
+)
+EOF
+
+ bazel build x:unwritable || fail "Failed the first compilation"
+
+ # Now modify the build file to force a rebuild while creating the same output
+ # within the write-protected directory.
+ cat > x/BUILD << 'EOF'
+genrule(
+ name = "unwritable",
+ srcs = [],
+ outs = ["unwritable/somefile.out"],
+ local = 1,
+ cmd = "echo 'Some other output' > $@; chmod -w $$(dirname $@)"
+)
+EOF
+
+ bazel build x:unwritable || fail "Failed 2nd compilation due to failure to delete output."
+}
+
+function test_delete_tree_in_unwritable_dir() {
+ mkdir -p x || fail "Can't create x"
+ cat > x/BUILD << 'EOF'
+genrule(
+ name = "unwritable",
+ srcs = [],
+ outs = ["unwritable/somedir"],
+ local = 1,
+ cmd = "mkdir -p $@; echo 'some output' > $@/somefile.out; chmod -w $$(dirname $@)"
+)
+EOF
+
+ bazel build x:unwritable || fail "Failed the first compilation"
+
+ # Now modify the build file to force a rebuild while creating the same output
+ # within the write-protected directory.
+ cat > x/BUILD << 'EOF'
+genrule(
+ name = "unwritable",
+ srcs = [],
+ outs = ["unwritable/somedir"],
+ local = 1,
+ cmd = "mkdir -p $@; echo 'some other output' > $@/somefile.out; chmod -w $$(dirname $@)"
+)
+EOF
+
+ bazel build x:unwritable || fail "Failed 2nd compilation due to failure to delete output."
+}
+
+run_suite "Force delete output tests"
\ No newline at end of file